package at.hl.okb.wsclient;

import static org.junit.Assert.assertTrue;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.heuristiclab.okb.wsclient.Exception.OKBWebServiceFailedException;
import com.heuristiclab.okb.wsclient.admin.AdministrationService;
import com.heuristiclab.okb.wsclient.admin.Algorithm;
import com.heuristiclab.okb.wsclient.admin.AlgorithmClass;
import com.heuristiclab.okb.wsclient.admin.ArrayOfAlgorithm;
import com.heuristiclab.okb.wsclient.admin.IAdministrationService;
import com.heuristiclab.okb.wsclient.admin.ObjectFactory;


/**
 * @author HolperM
 * 
 */
public class OKBClientTest {

	
	AdministrationService srv = null;
	IAdministrationService port = null;

	/**
	 * @throws java.lang.Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
		this.srv = new AdministrationService();
		this.port = srv.getJavaAdministrationService(); //.getWSHttpBindingIAdministrationService1();
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}
	
	//TODO: fix -->Problem deleting existing Algorithm
	@Test
	public void AddAlgorithmTest() throws Exception {

		ObjectFactory fac = new ObjectFactory();
		Long retval = 0L;
		
		//delete existing Algo and Class first
		if (port.getAlgorithmClass(1000L)!=null) {
			port.deleteAlgorithmClass(1000L);
		}
		if (port.getAlgorithm(1000L)!=null) {
			port.deleteAlgorithm(1000L);
		}
	
		//add AlgorithmClassId first
		AddAlgorithmClassTest();
		Algorithm a = fac.createAlgorithm();
			
		a.setAlgorithmClassId(1000L);
		a.setDescription(fac.createNamedOKBItemDescription("a new Algo"));
		a.setId(1000L);
		a.setName(fac.createNamedOKBItemName("Algorithm Name 6"));
		a.setPlatformId(1L);
		try {
			retval = port.addAlgorithm(a);
		} catch (Exception e) {
			throw new OKBWebServiceFailedException(e.getMessage());
		}
		assertTrue("Algortihm wasn't added", retval > 0);
	}
	
	@Test
	public void AddAlgorithmClassTest() throws Exception {

		ObjectFactory fac = new ObjectFactory();
		Long retval = 0L;
		
		//delete existing Algo first (if exists)
		if (port.getAlgorithmClass(1000L)!=null) {
			port.deleteAlgorithmClass(1000L);
		}		
		
		AlgorithmClass a = fac.createAlgorithmClass();
		a.setId(1000L);
		a.setName(fac.createNamedOKBItemName("a new AlgoClass"));
		
		try {
			retval = port.addAlgorithmClass(a);
		} catch (Exception e) {
			throw new OKBWebServiceFailedException(e.getMessage());
		}
		assertTrue("AlgortihmClass wasn't added", retval > 0);
	}	

	@Test
	public void GetAlgorithmsTest() {

		ArrayOfAlgorithm algos = port.getAlgorithms();
		
		for (Algorithm algo : algos.getAlgorithm()) {
			System.out.println("algo ClassId:=" + algo.getAlgorithmClassId());
			System.out.println("algo Id:=" + algo.getId());
			System.out.println("algo PlattformId:=" + algo.getPlatformId());
			System.out.println("algo Class:=" + algo.getClass());
			System.out.println("algo Description:="
					+ algo.getDescription().getValue());
			System.out.println("algo Name:=" + algo.getName().getValue());
		}
		assertTrue("No Algorithms found!", algos.getAlgorithm().size() > 0);
	}
	
	
	
	
//
//	@Test
//	public void GetDataTypesTest() {
//
//		ArrayOfDataType dataTypes = port.getDataTypes();
//
//		for (DataType dataType : dataTypes.getDataType()) {
//			System.out.println("algo Id:=" + dataType.getId());
//			System.out.println("algo platformId:=" + dataType.getPlatformId());
//			System.out.println("algo Name:=" + dataType.getName());
//			System.out.println("algo Class:=" + dataType.getClass());
//			System.out.println("algo SQLName:="
//					+ dataType.getSqlName().getValue());
//		}
//		assertTrue("No dataTypes found!", dataTypes.getDataType().size() > 0);
//	}
//
//	@Test
//	public void GetPlatFormTest() {
//		Platform f = port.getPlatform(1L);
//		assertTrue(f.getName().getValue().length() > 0);
//	}
//
//	AdministrationServiceClient client = new AdministrationServiceClient();
//
//	@Test
//	public void testGetPlatform() {
//		client.getPlatformId("ECJ");
//	}
	
	
}
